require 'courgette/directory_analyser'

class DependencyAnalyzer
  def initialize
    @graph = Courgette::DirectoryAnalyser.new.tap { |da| da.analyse('**/*.rb') }.graph
    @stats = @graph.nodes.map { |node| { :in => @graph.dependency_count(node), :out => @graph.depender_count(node), :name => node.join("::") } }
  end
  
  def get_in_stats(n)
    get_stats(maybe_take(@stats.sort { |a, b| b[:in] <=> a[:in] }, n), :in)
  end
  
  def get_out_stats(n)
    get_stats(maybe_take(@stats.sort { |a, b| b[:out] <=> a[:out] }, n), :out)
  end
  
  def get_stats(stat_array, stat_index)
    stat_array.map { |x| "#{x[stat_index]} #{x[:name]}" }.join("\n")
  end

  private
  def maybe_take(array, n)
    if n
      array.take(n)
    else
      array
    end
  end
end